package com.example.ponguoc;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import org.andengine.extension.multiplayer.adt.message.client.ClientMessage;

public class GameClientMessages {
	
	public static final short CLIENT_MESSAGE_MOVE_PADDLE = 100;
	public static final short CLIENT_MESSAGE_PAUSE_GAME = 101;
	public static final short CLIENT_MESSAGE_RESTART_GAME = 102;
	public static final short CLIENT_MESSAGE_FINISH_GAME = 103;
	
	public static class ClientMsgMovePaddle extends ClientMessage{

		public int mPaddleID;
		public float mX;
		
		public ClientMsgMovePaddle() {

		}

		public ClientMsgMovePaddle(final int pID, final float pX) {
			this.mPaddleID = pID;
			this.mX = pX;
		}
		
		@Override
		public short getFlag() {
			return CLIENT_MESSAGE_MOVE_PADDLE;
		}
		
		public void setPaddleID(final int pPaddleID, final float pX) {
			this.mPaddleID = pPaddleID;
			this.mX = pX;
		}
		
		
		@Override
		protected void onReadTransmissionData(DataInputStream pDataInputStream)
				throws IOException {
			this.mPaddleID = pDataInputStream.readInt();
			this.mX = pDataInputStream.readFloat();
		}

		@Override
		protected void onWriteTransmissionData(
				DataOutputStream pDataOutputStream) throws IOException {
			pDataOutputStream.writeInt(this.mPaddleID);
			pDataOutputStream.writeFloat(this.mX);
		}
		
	}
	
	public static class ClientMsgPauseGame extends ClientMessage{

		public boolean mPaused;
		
		public ClientMsgPauseGame(){
			
		}
		
		public ClientMsgPauseGame(boolean pPaused){
			this.mPaused = pPaused;
		}
		@Override
		public short getFlag() {
			return CLIENT_MESSAGE_PAUSE_GAME;
		}

		public void setPaused(boolean pPaused){
			this.mPaused = pPaused;
		}
		@Override
		protected void onReadTransmissionData(DataInputStream pDataInputStream)
				throws IOException {
			this.mPaused = pDataInputStream.readBoolean();
			
		}

		@Override
		protected void onWriteTransmissionData(
				DataOutputStream pDataOutputStream) throws IOException {
			pDataOutputStream.writeBoolean(this.mPaused);
			
		}
		
	}
	
	public static class ClientMsgRestartGame extends ClientMessage{

		public ClientMsgRestartGame(){
			
		}
		
		@Override
		public short getFlag() {
			// TODO Auto-generated method stub
			return CLIENT_MESSAGE_RESTART_GAME;
		}

		@Override
		protected void onReadTransmissionData(DataInputStream pDataInputStream)
				throws IOException {
			// TODO Auto-generated method stub
			
		}

		@Override
		protected void onWriteTransmissionData(
				DataOutputStream pDataOutputStream) throws IOException {
			// TODO Auto-generated method stub
			
		}
		
	}
	
	public static class ClientMsgFinishGame extends ClientMessage{

		public ClientMsgFinishGame(){
			
		}
		
		@Override
		public short getFlag() {
			// TODO Auto-generated method stub
			return CLIENT_MESSAGE_FINISH_GAME;
		}

		@Override
		protected void onReadTransmissionData(DataInputStream pDataInputStream)
				throws IOException {
			// TODO Auto-generated method stub
			
		}

		@Override
		protected void onWriteTransmissionData(
				DataOutputStream pDataOutputStream) throws IOException {
			// TODO Auto-generated method stub
			
		}
		
	}

}
