package com.example.ponguoc;

import org.andengine.engine.handler.IUpdateHandler;
import org.andengine.entity.primitive.Line;
import org.andengine.entity.primitive.Rectangle;
import org.andengine.entity.scene.IOnSceneTouchListener;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.text.Text;
import org.andengine.input.touch.TouchEvent;

import android.util.Log;
import android.util.SparseArray;

import com.example.ponguoc.GameClientMessages.ClientMsgMovePaddle;

/*-------------------------------------------------------------
 * -------------------- NOT IN USE-----------------------------
 * ------------------------------------------------------------
 * ------------ substituted by GameActivity.java---------------
 * -----------------------------------------------------------*/
public class GameScene extends Scene implements IOnSceneTouchListener{
	
	public static final int TABLE_WIDTH = MainActivity.CAMERA_WIDTH;
	public static final int TABLE_HEIGHT = MainActivity.CAMERA_HEIGHT;
	public static final int PADDLE_WIDTH = 80;
	public static final int PADDLE_HEIGHT = 20;
	public static final int BALL_SIDE = 15;
	
	public Options gameOptions;
	public Rectangle mBall;
	//public Paddle myPaddle, opponentPaddle;
	public SparseArray<Paddle> mPaddleList = new SparseArray<Paddle>();
	//public Score myScore, opponentScore;
	public SparseArray<Text> mScoreList = new SparseArray<Text>();
	public MainActivity activity;
	public float mMyPaddleYPos;
	public int mPaddleID;
	public int mType;
	public GameClient mClient;
	
	
	
	public GameScene(Options gameOptions, int type){
		this.gameOptions = gameOptions;
		activity = MainActivity.getSharedInstance();
		this.mType = type;
		
		if(type==MainActivity.IS_SERVER){
			mPaddleID = 0;
			activity.runOnUiThread(new Runnable(){
				public void run(){
				activity.showDialog(MainActivity.IS_SERVER);
				}
			});
		}
		else if(type == MainActivity.IS_CLIENT){
			mPaddleID = 1;
			activity.runOnUiThread(new Runnable(){
				public void run(){
				activity.showDialog(MainActivity.IS_CLIENT);
				}
			});
		}
		else mPaddleID = -1;
		
		//create ball
		mBall = new Rectangle(0, 0, BALL_SIDE, BALL_SIDE, activity.getVertexBufferObjectManager());
		mBall.setPosition(TABLE_WIDTH/2, TABLE_HEIGHT/2);
		attachChild(mBall);
		
		//create table lines
		attachChild(new Line(0, 0, 0, TABLE_HEIGHT, activity.getVertexBufferObjectManager())); //left line
		attachChild(new Line(0, TABLE_HEIGHT, TABLE_WIDTH, TABLE_HEIGHT, activity.getVertexBufferObjectManager())); //top line
		attachChild(new Line(TABLE_WIDTH-1, TABLE_HEIGHT, TABLE_WIDTH-1, 0, activity.getVertexBufferObjectManager())); //right line
		attachChild(new Line(TABLE_WIDTH, 1, 0, 1, activity.getVertexBufferObjectManager())); //bottom line
		attachChild(new Line(0, TABLE_HEIGHT/2, TABLE_WIDTH, TABLE_HEIGHT/2, activity.getVertexBufferObjectManager())); //centre line
		
		//create paddles
		Paddle paddleBottom = new Paddle(PADDLE_WIDTH, PADDLE_HEIGHT);
		Paddle paddleTop = new Paddle(PADDLE_WIDTH, PADDLE_HEIGHT);
		paddleBottom.setPosition(TABLE_WIDTH/2, 20);
		paddleTop.setPosition(TABLE_WIDTH/2, TABLE_HEIGHT-20);
		mPaddleList.put(MainActivity.IS_SERVER, paddleBottom);
		mPaddleList.put(MainActivity.IS_CLIENT, paddleTop);
		
		attachChild(paddleBottom);
		attachChild(paddleTop);
		
		//create score
		Text scoreBottom = new Text(0, 0, MainActivity.getSharedInstance().mFontScore, "0",
				MainActivity.getSharedInstance().getVertexBufferObjectManager());
		Text scoreTop = new Text(0, 0, MainActivity.getSharedInstance().mFontScore, "0",
				MainActivity.getSharedInstance().getVertexBufferObjectManager());
		scoreBottom.setPosition(TABLE_WIDTH - 30, TABLE_HEIGHT/2 - 30);
		scoreTop.setPosition(30, TABLE_HEIGHT/2 + 30);
		mScoreList.put(MainActivity.IS_SERVER, scoreBottom);
		mScoreList.put(MainActivity.IS_CLIENT, scoreTop);
		
		attachChild(scoreBottom);
		attachChild(scoreTop);
		
		setOnSceneTouchListener(this);
		
		/*registerUpdateHandler(new IUpdateHandler() {
			@Override
			public void onUpdate(final float pSecondsElapsed) {
				if(mClient != null){
					mClient = activity.getClient();
					mClient.sendMessage(new ClientMsgMovePaddle(mPaddleID, mMyPaddleYPos));
					Log.i("pong", "onUpdate() entered, message sent");
				}
				else Log.i("pong", "onUpdate() entered, client still not created");
			}

			@Override
			public void reset() {}
		});*/
	}

	@Override
	public boolean onSceneTouchEvent(Scene pScene, TouchEvent pSceneTouchEvent) {
		Log.i("pong", "Touch event in GameScene (paddle listener)");
		this.mMyPaddleYPos = pSceneTouchEvent.getY();
		return true;
	}
	
	public void updatePaddle(final int paddleID, final float pX, final float pY) {
		this.mPaddleList.get(paddleID).setPosition(pX, pY);
	}

	public void updateBall(final float pX, final float pY) {
		this.mBall.setPosition(pX, pY);
	}
	
	public void updateScore(final int paddleID, final int points){
		this.mScoreList.get(paddleID).setText(String.valueOf(points));
	}
	
	public int getType(){
		return this.mType;
	}
	
	public int getPaddleID(){
		return this.mPaddleID;
	}
	
	public float getMyPaddleYPos(){
		return this.mMyPaddleYPos;
	}

}
