package com.example.ponguoc;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import org.andengine.extension.multiplayer.adt.message.server.ServerMessage;


public class GameServerMessages {
	
	// Server message flags, incrementing from the final client's flag value
		public static final short SERVER_MESSAGE_UPDATE_BALL = 1;
		public static final short SERVER_MESSAGE_UPDATE_PADDLE = 2;
		public static final short SERVER_MESSAGE_UPDATE_SCORE = 3;
		public static final short SERVER_MESSAGE_FINISH_GAME = 4;
		
		public static class ServerMsgUpdateBall extends ServerMessage{

			public float mX;
			public float mY;
			
			public ServerMsgUpdateBall() {}
			
			public ServerMsgUpdateBall(final float pX, final float pY) {
				this.mX = pX;
				this.mY = pY;
			}
			@Override
			public short getFlag() {
				return SERVER_MESSAGE_UPDATE_BALL;
			}
			
			public void set(final float pX,final float pY) {
				this.mX = pX;
				this.mY = pY;
			}
			
			public float getX(){
				return mX;
			}
			
			public float getY(){
				return mY;
			}

			@Override
			protected void onReadTransmissionData(
					DataInputStream pDataInputStream) throws IOException {
				this.mX = pDataInputStream.readFloat();
				this.mY = pDataInputStream.readFloat();
			}

			@Override
			protected void onWriteTransmissionData(
					DataOutputStream pDataOutputStream) throws IOException {
				pDataOutputStream.writeFloat(this.mX);
				pDataOutputStream.writeFloat(this.mY);
			}
			
		}
		
		public static class ServerMsgUpdatePaddle extends ServerMessage{

			public int mPaddleID;
			public float mX;
			public float mY;
			
			public ServerMsgUpdatePaddle(){
			}
			
			public ServerMsgUpdatePaddle(final int pPaddleID, final float pX, final float pY){
				this.mPaddleID = pPaddleID;
				this.mX = pX;
				this.mY = pY;
			}
			
			@Override
			public short getFlag() {
				return SERVER_MESSAGE_UPDATE_PADDLE;
			}
			
			public float getX(){
				return mX;
			}
			
			public float getY(){
				return mY;
			}
			
			public void set(final int pPaddleID, final float pX,final float pY) {
				this.mPaddleID = pPaddleID;
				this.mX = pX;
				this.mY = pY;
			}

			@Override
			protected void onReadTransmissionData(
					DataInputStream pDataInputStream) throws IOException {
				this.mPaddleID = pDataInputStream.readInt();
				this.mX = pDataInputStream.readFloat();
				this.mY = pDataInputStream.readFloat();
			}

			@Override
			protected void onWriteTransmissionData(
					DataOutputStream pDataOutputStream) throws IOException {
				pDataOutputStream.writeInt(this.mPaddleID);
				pDataOutputStream.writeFloat(this.mX);
				pDataOutputStream.writeFloat(this.mY);
			}
			
		}
		
		public static class ServerMsgUpdateScore extends ServerMessage{
			
			public int mPaddleID;
			public int mScore;
			
			public ServerMsgUpdateScore() {

			}
			
			public ServerMsgUpdateScore(final int pPaddleID, final int pScore) {
				this.mPaddleID = pPaddleID;
				this.mScore = pScore;
			}

			@Override
			public short getFlag() {
				return SERVER_MESSAGE_UPDATE_SCORE;
			}
			
			public void set(final int pPaddleID, final int pScore) {
				this.mPaddleID = pPaddleID;
				this.mScore = pScore;
			}

			@Override
			protected void onReadTransmissionData(
					DataInputStream pDataInputStream) throws IOException {
				this.mPaddleID = pDataInputStream.readInt();
				this.mScore = pDataInputStream.readInt();
			}

			@Override
			protected void onWriteTransmissionData(
					DataOutputStream pDataOutputStream) throws IOException {
				pDataOutputStream.writeInt(this.mPaddleID);
				pDataOutputStream.writeInt(this.mScore);
			}
			
		}
		
		public static class ServerMsgFinishGame extends ServerMessage{
			public short getFlag() {
				return SERVER_MESSAGE_FINISH_GAME;
			}

			@Override
			protected void onReadTransmissionData(
					DataInputStream pDataInputStream) throws IOException {
				//
			}

			@Override
			protected void onWriteTransmissionData(
					DataOutputStream pDataOutputStream) throws IOException {
				//
			}
		}
		

}
