package com.example.ponguoc;

import java.io.IOException;

import org.andengine.engine.Engine;
import org.andengine.engine.LimitedFPSEngine;
import org.andengine.engine.camera.Camera;
import org.andengine.engine.handler.IUpdateHandler;
import org.andengine.engine.options.EngineOptions;
import org.andengine.engine.options.ScreenOrientation;
import org.andengine.engine.options.resolutionpolicy.RatioResolutionPolicy;
import org.andengine.entity.scene.IOnSceneTouchListener;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.util.FPSLogger;
import org.andengine.extension.multiplayer.client.connector.ServerConnector;
import org.andengine.extension.multiplayer.client.connector.SocketConnectionServerConnector.ISocketConnectionServerConnectorListener;
import org.andengine.extension.multiplayer.server.connector.ClientConnector;
import org.andengine.extension.multiplayer.server.connector.SocketConnectionClientConnector.ISocketConnectionClientConnectorListener;
import org.andengine.extension.multiplayer.shared.SocketConnection;
import org.andengine.input.touch.TouchEvent;
import org.andengine.opengl.font.Font;
import org.andengine.opengl.font.FontFactory;
import org.andengine.ui.activity.SimpleBaseGameActivity;
import org.andengine.util.WifiUtils;
import org.andengine.util.WifiUtils.WifiUtilsException;

import com.example.ponguoc.GameClientMessages.ClientMsgMovePaddle;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.graphics.Color;
import android.util.Log;
import android.widget.EditText;
import android.widget.Toast;

public class MainActivity extends SimpleBaseGameActivity implements
		ISocketConnectionClientConnectorListener{
	public static final int CAMERA_WIDTH = 480;
	public static final int CAMERA_HEIGHT = 800;
	public static final int IS_SERVER = 0;
	public static final int IS_CLIENT = 1;
	public static final int IS_SINGLE = 2;
	public static final int FPS = 30;
	private static final String LOCALHOST_IP = "127.0.0.1";
	public static final int SERVER_PORT = 4444;
	 
	public Font mFontTitle;
	public Font mFontMenu;
	public Font mFontScore;
	public Camera mCamera;
	public Options mOptions;
	public GameClient mClient;
	public GameServer mServer;
	private String mServerIP = LOCALHOST_IP;

	 
	//A reference to the current scene
	public Scene mCurrentScene;
	public static MainActivity instance;
	@Override
	public EngineOptions onCreateEngineOptions() {
		instance = this;
	    mCamera = new Camera(0, 0, CAMERA_WIDTH, CAMERA_HEIGHT);
	 
	    return new EngineOptions(true, ScreenOrientation.PORTRAIT_SENSOR,
	    		new RatioResolutionPolicy(CAMERA_WIDTH, CAMERA_HEIGHT), mCamera);
	}
	
	public Engine onCreateEngine(final EngineOptions pEngineOptions) {
		//this.showDialog(DIALOG_CHOOSE_SERVER_OR_CLIENT_ID);

		return new LimitedFPSEngine(pEngineOptions, FPS);
	}

	@Override
	public void onCreateResources() 
			throws IOException {
		mFontTitle = FontFactory.createFromAsset(this.getFontManager(),this.getTextureManager(),
				256, 256, this.getAssets(), "fonts/stocky.ttf", 100f, true, Color.RED);
	    mFontTitle.load();
	    mFontMenu = FontFactory.createFromAsset(this.getFontManager(),this.getTextureManager(),
				256, 256, this.getAssets(), "fonts/stocky.ttf", 36f, true, Color.RED);
	    mFontMenu.load();

	}

	@Override
	public Scene onCreateScene() {
		mEngine.registerUpdateHandler(new FPSLogger());
		mCurrentScene = new TitleScene();
		mOptions = new Options();
		//mCurrentScene.setOnSceneTouchListener(this);
		

		return mCurrentScene;
	}
	

	public static MainActivity getSharedInstance() {
	    return instance;
	}
	 
	// to change the current main scene
	public void setCurrentScene(Scene scene) {
	    mCurrentScene = scene;
	    getEngine().setScene(mCurrentScene);
	}


	/*@Override
	public boolean onSceneTouchEvent(Scene pScene, TouchEvent pSceneTouchEvent) {
		if(mCurrentScene instanceof TitleScene){
			setCurrentScene(new MainMenuScene());
			Log.i("pong", "Current Scene is MainMenuScene");
			return true;
		}
		else
		return false;
	}*/
	
	public void setOptions(Options pOptions){
		mOptions = pOptions;
	}
	
	public Options getOptions(){
		return mOptions;
	}
	
	public GameClient getClient(){
		return mClient;
	}

	@Override
	public void onStarted(ClientConnector<SocketConnection> pClientConnector) {
		Log.i("pong", "External CLIENT: connection established");
		
	}

	@Override
	public void onTerminated(ClientConnector<SocketConnection> pClientConnector) {
		// TODO Auto-generated method stub
		
	}
	
	public void toast(final String pMessage) {
		this.runOnUiThread(new Runnable() {
			@Override
			public void run() {
				Toast.makeText(MainActivity.this, pMessage, Toast.LENGTH_SHORT).show();
			}
		});
	}
	
}
