package com.example.ponguoc;

import java.io.Serializable;

import org.andengine.entity.scene.menu.MenuScene;
import org.andengine.entity.scene.menu.MenuScene.IOnMenuItemClickListener;
import org.andengine.entity.scene.menu.item.IMenuItem;
import org.andengine.entity.scene.menu.item.TextMenuItem;

import android.content.Intent;
import android.os.Bundle;



public class MainMenuScene extends MenuScene implements IOnMenuItemClickListener, Serializable{

	MainActivity activity;
	Options gameOptions;
	final int SERVER_MODE = 0;
	final int CLIENT_MODE = 1;
	final int SINGLE_MODE = 2;
	final int SETTINGS_MODE = 3;
	
	
	public MainMenuScene() {
		super(MainActivity.getSharedInstance().mCamera);
		activity = MainActivity.getSharedInstance();
		
		// Define menu options
		IMenuItem serverButton = new TextMenuItem(SERVER_MODE, activity.mFontMenu,
				activity.getString(R.string.server_option), activity.getVertexBufferObjectManager());
		serverButton.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-200);
		IMenuItem clientButton = new TextMenuItem(CLIENT_MODE, activity.mFontMenu,
				activity.getString(R.string.client_option), activity.getVertexBufferObjectManager());
		clientButton.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-300);
		IMenuItem singleButton = new TextMenuItem(SINGLE_MODE, activity.mFontMenu,
				activity.getString(R.string.single_option), activity.getVertexBufferObjectManager());
		singleButton.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-400);
		IMenuItem settingsButton = new TextMenuItem(SETTINGS_MODE, activity.mFontMenu,
				activity.getString(R.string.settings_option), activity.getVertexBufferObjectManager());
		settingsButton.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-500);
		
		
		addMenuItem(serverButton);
		addMenuItem(clientButton);
		addMenuItem(singleButton);
		addMenuItem(settingsButton);
		
		setOnMenuItemClickListener(this);
		
		this.gameOptions = activity.getOptions();
	}

	@Override
	public boolean onMenuItemClicked(MenuScene pMenuScene, IMenuItem pMenuItem,
			float pMenuItemLocalX, float pMenuItemLocalY) {
		Intent gameIntent = new Intent(activity, GameActivity.class);
		Bundle b = new Bundle();
		
		switch(pMenuItem.getID()){
		case SERVER_MODE:
			this.gameOptions = activity.getOptions();
			b.putParcelable("options", gameOptions);
			b.putInt("type", MainActivity.IS_SERVER);
			gameIntent.putExtras(b);
			activity.startActivity(gameIntent);
			return true;
		case CLIENT_MODE:
			this.gameOptions = activity.getOptions();
			b.putParcelable("options", gameOptions);
			b.putInt("type", MainActivity.IS_CLIENT);
			gameIntent.putExtras(b);
			activity.startActivity(gameIntent);
			return true;
		case SINGLE_MODE:
			this.gameOptions = activity.getOptions();
			b.putParcelable("options", gameOptions);
			b.putInt("type", MainActivity.IS_SINGLE);
			gameIntent.putExtras(b);
			activity.startActivity(gameIntent);
			return true;
		case SETTINGS_MODE:
			this.setChildScene(new OptionsScene());
            return true;
		default:
			return false;
		}
	}
	
	
	

}
