package com.example.ponguoc;

import org.andengine.entity.scene.menu.MenuScene;
import org.andengine.entity.scene.menu.MenuScene.IOnMenuItemClickListener;
import org.andengine.entity.scene.menu.item.IMenuItem;
import org.andengine.entity.scene.menu.item.TextMenuItem;
import org.andengine.entity.text.Text;

public class OptionsScene extends MenuScene implements IOnMenuItemClickListener{
	
	public MainActivity activity;
	public Options mOptions = new Options();

	public OptionsScene(){
		super(MainActivity.getSharedInstance().mCamera);
		activity = MainActivity.getSharedInstance();
		
		Text title1 = new Text(0, 0, activity.mFontMenu, activity.getString(R.string.title_difficulty),
				activity.getVertexBufferObjectManager());
		title1.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-150);
		
		IMenuItem lowDiff = new TextMenuItem(Options.LOW, activity.mFontMenu,
				activity.getString(R.string.low_difficulty), activity.getVertexBufferObjectManager());
		lowDiff.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-300);
		IMenuItem mediumDiff = new TextMenuItem(Options.MEDIUM, activity.mFontMenu,
				activity.getString(R.string.medium_difficulty), activity.getVertexBufferObjectManager());
		mediumDiff.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-400);
		IMenuItem highDiff = new TextMenuItem(Options.HIGH, activity.mFontMenu,
				activity.getString(R.string.high_difficulty), activity.getVertexBufferObjectManager());
		highDiff.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-500);
		
		attachChild(title1);
		addMenuItem(lowDiff);
		addMenuItem(mediumDiff);
		addMenuItem(highDiff);
		
		setOnMenuItemClickListener(this);
	}

	@Override
	public boolean onMenuItemClicked(MenuScene pMenuScene, IMenuItem pMenuItem,
			float pMenuItemLocalX, float pMenuItemLocalY) {
		switch(pMenuItem.getID()){
		case(Options.LOW):
			mOptions.setDifficulty(Options.LOW);
			activity.setOptions(mOptions);
			pMenuScene.closeMenuScene();
			return true;
		case(Options.MEDIUM):
			mOptions.setDifficulty(Options.MEDIUM);
			activity.setOptions(mOptions);
			pMenuScene.closeMenuScene();
			return true;
		case(Options.HIGH):
			mOptions.setDifficulty(Options.HIGH);
			activity.setOptions(mOptions);
			pMenuScene.closeMenuScene();
			return true;
		
		default: return false;
		}
	}

}
