package com.example.ponguoc;

import org.andengine.entity.scene.menu.MenuScene;
import org.andengine.entity.scene.menu.MenuScene.IOnMenuItemClickListener;
import org.andengine.entity.scene.menu.item.IMenuItem;
import org.andengine.entity.scene.menu.item.TextMenuItem;

import android.util.Log;

public class PauseScene extends MenuScene implements IOnMenuItemClickListener{
	
	public static final int MENU_MODE = 0;
	public static final int RESUME_MODE = 1;
	public static final int RESTART_MODE = 2;

	public GameActivity activity;

	public PauseScene(){
		super(GameActivity.getSharedInstance().mCamera);
		activity = GameActivity.getSharedInstance();
		
		IMenuItem resumeButton = new TextMenuItem(RESUME_MODE, activity.mFontMenu,
				activity.getString(R.string.resume_option), activity.getVertexBufferObjectManager());
		resumeButton.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-200);
		IMenuItem restartButton = new TextMenuItem(RESTART_MODE, activity.mFontMenu,
				activity.getString(R.string.restart_option), activity.getVertexBufferObjectManager());
		restartButton.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-300);
		IMenuItem menuButton = new TextMenuItem(MENU_MODE, activity.mFontMenu,
				activity.getString(R.string.backtomenu_option), activity.getVertexBufferObjectManager());
		menuButton.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight()-400);
		
		addMenuItem(resumeButton);
		addMenuItem(restartButton);
		addMenuItem(menuButton);
		
		setOnMenuItemClickListener(this);
	}

	@Override
	public boolean onMenuItemClicked(MenuScene pMenuScene, IMenuItem pMenuItem,
			float pMenuItemLocalX, float pMenuItemLocalY) {
		switch(pMenuItem.getID()){
		case RESUME_MODE:
			Log.i("pong", "resume clicked");
			activity.resumePausedGame();
			pMenuScene.closeMenuScene();
			return true;
			
		case MENU_MODE:
			pMenuScene.closeMenuScene();
			activity.sendFinishMessage();
			
		case RESTART_MODE:
			pMenuScene.closeMenuScene();
			activity.sendRestartMessage();
		}
		return false;
	}
}
