package com.example.ponguoc;

import org.andengine.entity.IEntity;
import org.andengine.entity.modifier.DelayModifier;
import org.andengine.entity.modifier.MoveYModifier;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.text.Text;


public class TitleScene extends Scene{
	
	MainActivity activity;
	Text skip_title1, skip_title2;
	
	public TitleScene(){
		setBackground(new Background(0,0,0));
		activity = MainActivity.getSharedInstance();
		Text title1 = new Text(0, 0, activity.mFontTitle, activity.getString(R.string.title_1), activity.getVertexBufferObjectManager());
		Text title2 = new Text(0, 0, activity.mFontTitle, activity.getString(R.string.title_2), activity.getVertexBufferObjectManager());
		skip_title1 = new Text(0, 0, activity.mFontMenu, activity.getString(R.string.skip_title1), activity.getVertexBufferObjectManager());
		skip_title2 = new Text(0, 0, activity.mFontMenu, activity.getString(R.string.skip_title2), activity.getVertexBufferObjectManager());
		title1.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight() + title1.getHeight());
		title2.setPosition(activity.mCamera.getWidth()/2, -title2.getHeight());
		skip_title1.setPosition(activity.mCamera.getWidth()/2, activity.mCamera.getHeight() / 3);
		skip_title2.setPosition(activity.mCamera.getWidth()/2, (activity.mCamera.getHeight() / 3) - 50);
		
		attachChild(title1);
		attachChild(title2);
		 
		title1.registerEntityModifier(new MoveYModifier(1, title1.getY(), 2*activity.mCamera.getHeight() / 3 ));
		title2.registerEntityModifier(new MoveYModifier(1, title2.getY(), 2*activity.mCamera.getHeight() / 3 - title2.getHeight()));
		loadResources();
	}
	
	public void loadResources(){
		DelayModifier dMod = new DelayModifier(2){
		    @Override
		    protected void onModifierFinished(IEntity pItem) {
		        attachChild(skip_title1);
		    }
		};
		registerEntityModifier(dMod);
		
		DelayModifier dMod3 = new DelayModifier(3){
		    @Override
		    protected void onModifierFinished(IEntity pItem) {
		        attachChild(skip_title2);
		    }
		};
		registerEntityModifier(dMod3);
		
		DelayModifier dMod2 = new DelayModifier(5){
			@Override
		    protected void onModifierFinished(IEntity pItem) {
		        activity.setCurrentScene(new MainMenuScene());
		    }
		};
		registerEntityModifier(dMod2);
	}
	
	
	
}
